com.google.cloud.dataflow.sdk.transforms.display

## Class DisplayData.Item<T>

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.display.DisplayData.Item<T>

All Implemented Interfaces:
  Serializable

Enclosing class:
  DisplayData

    public static final class DisplayData.Item<T>
    extends Object
    implements Serializable

`Items` are the unit of display data. Each item is identified by a given key and namespace from the component the display item belongs to.

`Items` are registered via `DisplayData.Builder.add(com.google.cloud.dataflow.sdk.transforms.display.DisplayData.Item<?>)` within `HasDisplayData.populateDisplayData(com.google.cloud.dataflow.sdk.transforms.display.DisplayData.Builder)` implementations.

See Also:
  Serialized Form

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `equals(Object obj)`
`String` `getKey()` The key for the display item.
`String` `getLabel()` Retrieve the optional label for an item.
`String` `getLinkUrl()` Retrieve the optional link URL for an item.
`String` `getNamespace()` The namespace for the display item.
`Object` `getShortValue()` Return the optional short value for an item, or null if none is provided.
`DisplayData.Type` `getType()` Retrieve the `DisplayData.Type` of display data.
`Object` `getValue()` Retrieve the value of the display item.
`int` `hashCode()`
`String` `toString()`
`DisplayData.Item<T>` `withLabel(String label)` Set the item `label`.
`DisplayData.Item<T>` `withLinkUrl(String url)` Set the item `link url`.
`DisplayData.Item<T>` `withNamespace(Class<?> namespace)` Set the item `namespace` from the given `Class`.
`DisplayData.Item<T>` `withNamespace(String namespace)`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Method Detail

#### getNamespace

    @Nullable
    public String getNamespace()

The namespace for the display item. The namespace defaults to the component which the display item belongs to.

#### getKey

    public String getKey()

The key for the display item. Each display item is created with a key and value via {@link DisplayData#item).

#### getType

    public DisplayData.Type getType()

Retrieve the `DisplayData.Type` of display data. All metadata conforms to a predefined set of allowed types.

#### getValue

    @Nullable
    public Object getValue()

Retrieve the value of the display item. The value is translated from the input to `DisplayData.item(java.lang.String, java.lang.String)` into a format suitable for display. Translation is based on the item's `type`.

The value will only be null if the input value during creation was null.

#### getShortValue

    public Object getShortValue()

Return the optional short value for an item, or null if none is provided.

The short value is an alternative display representation for items having a long display value. For example, the `value` for `DisplayData.Type.JAVA_CLASS` items contains the full class name with package, while the short value contains just the class name. A `value` will be provided for each display item, and some types may also provide a short-value. If a short value is provided, display data consumers may choose to display it instead of or in addition to the `value`.

#### getLabel

    @Nullable
    public String getLabel()

Retrieve the optional label for an item. The label is a human-readable description of what the metadata represents. UIs may choose to display the label instead of the item key.

If no label was specified, this will return `null`.

#### getLinkUrl

    @Nullable
    public String getLinkUrl()

Retrieve the optional link URL for an item. The URL points to an address where the reader can find additional context for the display data.

If no URL was specified, this will return `null`.

#### withNamespace

    public DisplayData.Item<T> withNamespace(Class<?> namespace)

Set the item `namespace` from the given `Class`.

This method does not alter the current instance, but instead returns a new `DisplayData.Item` with the namespace set.

#### withNamespace

    public DisplayData.Item<T> withNamespace(String namespace)

See Also:
  `withNamespace(Class)`

#### withLabel

    public DisplayData.Item<T> withLabel(String label)

Set the item `label`.

Specifying a null value will clear the label if it was previously defined.

This method does not alter the current instance, but instead returns a new `DisplayData.Item` with the label set.

#### withLinkUrl

    public DisplayData.Item<T> withLinkUrl(String url)

Set the item `link url`.

Specifying a null value will clear the link url if it was previously defined.

This method does not alter the current instance, but instead returns a new `DisplayData.Item` with the link url set.

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`